Subject: Re: [PATCH] core, nfqueue, openvswitch: Orphan frags in skb_zerocopy and handle errors

From: Zoltan Kiss <[email-masked]>
Date: Wed, 19 Mar 2014 21:07:08 +0000

On 19/03/14 20:47, Thomas Graf wrote:
> On 03/19/2014 09:38 PM, Zoltan Kiss wrote:
>> skb_zerocopy can copy elements of the frags array between skbs, but it
>> doesn't
>> orphan them. Also, it doesn't handle errors, so this patch takes care
>> of that
>> as well.
>>
>> Signed-off-by: Zoltan Kiss <[email-masked]>
>> ---
>
>> +    if (unlikely(skb_orphan_frags(to, GFP_ATOMIC))) {
>> +        skb_tx_error(to);
>> +        return -ENOMEM;
>>       }
>
> I think you should move this down to right before we iterate over the
> frags.

I agree, I was mislead by that __skb_fill_page_desc, but now I see it is 
actually the head buffer of the source, not a frag from there. And in 
case of a failure in skb_copy_bits we can spare an orphan_frag.

Zoli